# ************************************************************************
# ************* GENERACIÓN DE TABULADOS TOMO II - SERVICIOS  *************
# ************************************************************************

# ********************************************************************** #
# Instituto Nacional de Estadística y Censos (INEC)                      #
# Fuente: Encuesta Estructural Empresarial 2024                          #
# Responsable: Unidad de Gestión de Estadísticas Estructurales (GESE)    #
# ********************************************************************** #
# Fecha de elaboración: 30/01/2026                                       #
# Fecha última modificación: 23/02/2026                                  #
# ********************************************************************** #
# Elaborado por:                                                         #
# Gestión de Estadísticas Estructurales - GESE                           #
# Instituto Nacional de Estadística y Censos (INEC)                      #
# ********************************************************************** #
# Revisado por:                                                          #
# Roberto Chaves                                                         #
# Jefe de Gestión de Estadísticas Estructurales - GESE                   #
# Instituto Nacional de Estadística y Censos (INEC)                      #
# Roberto_Chaves@inec.gob.ec                                             #
# ********************************************************************** #
# Aprobado por:                                                          #
# Diana Barco                                                            #
# Directora de Estadísticas Económicas (DECON)                           #
# Instituto Nacional de Estadística y Censos (INEC)                      #
# Diana_Barco@inec.gob.ec                                                #
##########################################################################

#========================================================================#
# FUNCIONES                                                              #
#========================================================================#

"Carga de librerías"

enesem_lib <- function(libreria) {
  if (!requireNamespace(as.character(libreria), quietly = TRUE)) {
    install.packages(as.character(libreria))
  }
  library(libreria, character.only = TRUE)
}

#========================================================================#
# CARGAR LIBRERÍAS                                                       #
#========================================================================#

enesem_lib("tidyverse")
enesem_lib("lubridate")
enesem_lib("haven")
enesem_lib("openxlsx")
enesem_lib("janitor")

# **** TABULADOS TOMO II - SERVICIOS (2024) *** -------------------------------------------------

#Establecer la dirección de trabajo ----

"Estimado Usuario. Por favor en el disco C: de su computadora, crear una carpeta llamada 
Tabulados Tomo II, y coloque la BDD de la encuesta (2024_ENESEM_BDD_Servicios.sav) , sintaxis y el diseño
en excel denominado DISEÑO_SERV.xlsx. 
En esta carpeta se exportarán los resultados de los tabulados."

setwd("C:/Tabulados Tomo II")

#Abrir directorio.
dir()

# *** Cargar base de datos****

dat <- read_sav("2024_ENESEM_BDD_Servicios.sav") #En caso de haber editado el nombre de la BDD reemplazarlo en esta línea

# dat <-  read_csv("2024_ENESEM_BDD_Servicios.csv") #En caso de que se descargue la base de datos en formato csv, quitar comentario (#) de esta línea de código y comentar (#) el comando read_sav.

######### 1) TABULADOS SERVICIOS  #########

servicios <- dat %>% 
  group_by(cod_cpc, cod_cpc_desc) %>% 
  summarise(nac = sum(valor_ventas_n, na.rm=TRUE),
            ext = sum(valor_ventas_e, na.rm=TRUE)) 

suma <- c(colSums(servicios[,3:4])) 

servicios <- bind_rows(servicios, suma) %>% 
  arrange(!is.na(cod_cpc)) 

servicios[1,2] <- "Total Nacional"  

## renombrar variables ---- 
names (servicios) = c ("CPC Ver. 2.0",
                       "Descripción",
                       "Valor vendido - Nacional",
                       "Valor vendido - Extranjero")

# ============================================================================ #
#####               DISEÑO Y EXPORTACIÓN DE TABULADOS A EXCEL              ##### 
# ============================================================================ #

"En esta sección se diseñará y exportará los tabulados en formato excel"

##### Configuración tabulados #####

serv <- loadWorkbook("DISEÑO_SERV.xlsx")

##### CREACIÓN #####

writeData(serv,
          "C1",
          servicios, 
          startRow = 3, 
          startCol = 1,  
          colNames = TRUE)

##### EXPORTACIÓN #####

anio_inv <- floor_date(today(), "day") %>%
  str_sub(1, 4) %>% 
  as.numeric() %>% 
  sum(-2, na.rm = T) %>% 
  str_c(.,"_","ENESEM_Tabulado_Servicios.xlsx")

saveWorkbook(serv, anio_inv,overwrite = TRUE)

